# Glasgow Haskell Compiler Users Guide

# 7.13. Debugging the compiler

HACKER TERRITORY. HACKER TERRITORY. (You were warned.)

## 7.13.1. Dumping out compiler intermediate structures

`-ddump-` ⟨pass⟩

  Make a debugging dump after pass `<pass>` (may be common enough to need a short form…). You can get all of these at once (lots of output) by using `-v5`, or most of them with `-v4`. You can prevent them from clogging up your standard output by passing `-ddump-to-file`. Some of the most useful ones are:

  `-ddump-to-file```

    Causes the output from all of the flags listed below to be dumped to a file. The file name depends upon the output produced; for instance, output from `-ddump-simpl` will end up in `module.dump-simpl`.

  `-ddump-parsed```

    Dump parser output

  `-ddump-rn```

    Dump renamer output

  `-ddump-tc```

    Dump typechecker output

  `-ddump-splices```

    Dump Template Haskell expressions that we splice in, and what Haskell code the expression evaluates to.

  `-dth-dec-file``=⟨file⟩`

    Dump expansions of all top-level Template Haskell splices into ⟨file⟩.

  `-ddump-types```

    Dump a type signature for each value defined at the top level of the module. The list is sorted alphabetically. Using `-dppr-debug` dumps a type signature for all the imported and system-defined things as well; useful for debugging the compiler.

  `-ddump-deriv```

    Dump derived instances

  `-ddump-ds```

    Dump desugarer output

  `-ddump-spec```

    Dump output of specialisation pass

  `-ddump-rules```

    Dumps all rewrite rules specified in this module; see Controlling what’s going on in rewrite rules.

  `-ddump-rule-firings```

    Dumps the names of all rules that fired in this module

  `-ddump-rule-rewrites```

    Dumps detailed information about all rules that fired in this module

  `-ddump-vect```

    Dumps the output of the vectoriser.

  `-ddump-simpl```

    Dump simplifier output (Core-to-Core passes)

  `-ddump-inlinings```

    Dumps inlining info from the simplifier

  `-ddump-stranal```

    Dump strictness analyser output

  `-ddump-str-signatures```

    Dump strictness signatures

  `-ddump-cse```

    Dump common subexpression elimination (CSE) pass output

  `-ddump-worker-wrapper```

    Dump worker/wrapper split output

  `-ddump-occur-anal```

    Dump “occurrence analysis” output

  `-ddump-prep```

    Dump output of Core preparation pass

  `-ddump-stg```

    Dump output of STG-to-STG passes

  `-ddump-cmm```

    Print the C– code out.

  `-ddump-opt-cmm```

    Dump the results of C– to C– optimising passes.

  `-ddump-asm```

    Dump assembly language produced by the native code generator

  `-ddump-llvm```

    Implies: | `-fllvm`

    LLVM code from the LLVM code generator

  `-ddump-bcos```

    Dump byte-code compiler output

  `-ddump-foreign```

    dump foreign export stubs

`-ddump-simpl-iterations```

  Show the output of each iteration of the simplifier (each run of the simplifier has a maximum number of iterations, normally 4). This outputs even more information than `-ddump-simpl-phases`.

`-ddump-simpl-stats```

  Dump statistics about how many of each kind of transformation too place. If you add `-dppr-debug` you get more detailed information.

`-ddump-if-trace```

  Make the interface loader be real chatty about what it is up to.

`-ddump-tc-trace```

  Make the type checker be real chatty about what it is up to.

`-ddump-vt-trace```

  Make the vectoriser be real chatty about what it is up to.

`-ddump-rn-trace```

  Make the renamer be real chatty about what it is up to.

`-ddump-rn-stats```

  Print out summary of what kind of information the renamer had to bring in.

`-dverbose-core2core```
`-dverbose-stg2stg```

  Show the output of the intermediate Core-to-Core and STG-to-STG passes, respectively. (lots of output!) So: when we’re really desperate:

      % ghc -noC -O -ddump-simpl -dverbose-core2core -dcore-lint Foo.hs

`-dshow-passes```

  Print out each pass name, its runtime and heap allocations as it happens. Note that this may come at a slight performance cost as the compiler will be a bit more eager in forcing pass results to more accurately account for their costs.

  Two types of messages are produced: Those beginning with `***` are denote the beginning of a compilation phase whereas those starting with `!!!` mark the end of a pass and are accompanied by allocation and runtime statistics.

`-ddump-core-stats```

  Print a one-line summary of the size of the Core program at the end of the optimisation pipeline.

`-dfaststring-stats```

  Show statistics on the usage of fast strings by the compiler.

`-dppr-debug```

  Debugging output is in one of several “styles.” Take the printing of types, for example. In the “user” style (the default), the compiler’s internal ideas about types are presented in Haskell source-level syntax, insofar as possible. In the “debug” style (which is the default for debugging output), the types are printed in with explicit foralls, and variables have their unique-id attached (so you can check for things that look the same but aren’t). This flag makes debugging output appear in the more verbose debug style.

## 7.13.2. Formatting dumps

`-dppr-user-length```

  In error messages, expressions are printed to a certain “depth”, with subexpressions beyond the depth replaced by ellipses. This flag sets the depth. Its default value is 5.

`-dppr-cols``=N`

  Set the width of debugging output. Use this if your code is wrapping too much. For example: `-dppr-cols=200`.

`-dppr-case-as-let```

  Print single alternative case expressions as though they were strict let expressions. This is helpful when your code does a lot of unboxing.

`-dno-debug-output```

  Suppress any unsolicited debugging output. When GHC has been built with the `DEBUG` option it occasionally emits debug output of interest to developers. The extra output can confuse the testing framework and cause bogus test failures, so this flag is provided to turn it off.

## 7.13.3. Suppressing unwanted information

Core dumps contain a large amount of information. Depending on what you are doing, not all of it will be useful. Use these flags to suppress the parts that you are not interested in.

`-dsuppress-all```

  Suppress everything that can be suppressed, except for unique ids as this often makes the printout ambiguous. If you just want to see the overall structure of the code, then start here.

`-dsuppress-uniques```

  Suppress the printing of uniques. This may make the printout ambiguous (e.g. unclear where an occurrence of ‘x’ is bound), but it makes the output of two compiler runs have many fewer gratuitous differences, so you can realistically apply `diff`. Once `diff` has shown you where to look, you can try again without `-dsuppress-uniques`

`-dsuppress-idinfo```

  Suppress extended information about identifiers where they are bound. This includes strictness information and inliner templates. Using this flag can cut the size of the core dump in half, due to the lack of inliner templates

`-dsuppress-unfoldings```

  Suppress the printing of the stable unfolding of a variable at its binding site.

`-dsuppress-module-prefixes```

  Suppress the printing of module qualification prefixes. This is the `Data.List` in `Data.List.length`.

`-dsuppress-type-signatures```

  Suppress the printing of type signatures.

`-dsuppress-type-applications```

  Suppress the printing of type applications.

`-dsuppress-coercions```

  Suppress the printing of type coercions.

## 7.13.4. Checking for consistency

`-dcore-lint```

  Turn on heavyweight intra-pass sanity-checking within GHC, at Core level. (It checks GHC’s sanity, not yours.)

`-dstg-lint```

  Ditto for STG level. (note: currently doesn’t work).

`-dcmm-lint```

  Ditto for C– level.

## 7.13.5. Checking for determinism

`-dinitial-unique``=⟨s⟩`

  Start `UniqSupply` allocation from ⟨s⟩.

`-dunique-increment``=⟨i⟩`

  Set the increment for the generated `Unique`’s to ⟨i⟩.

  This is useful in combination with `-dinitial-unique` to test if the generated files depend on the order of `Unique`’s.

  Some interesting values:

  - `-dinitial-unique=0 -dunique-increment=1` - current sequential `UniqSupply`
  - `-dinitial-unique=16777215 -dunique-increment=-1` - `UniqSupply` that generates in decreasing order
  - `-dinitial-unique=1 -dunique-increment=PRIME` - where PRIME big enough to overflow often - nonsequential order